/*
 * BigSIPPerformanceApp.java
 */

package bigsipperformance;

import org.jdesktop.application.Application;
import org.jdesktop.application.SingleFrameApplication;

/**
 * The main class of the application.
 */
public class BigSIPPerformanceApp extends SingleFrameApplication {
    private static Configurations config;

    /**
     * At startup create and show the main frame of the application.
     */
    @Override protected void startup() {
        show(new BigSIPPerformanceView(this, config));
    }

    /**
     * This method is to initialize the specified window by injecting resources.
     * Windows shown in our application come fully initialized from the GUI
     * builder, so this additional configuration is not needed.
     */
    @Override protected void configureWindow(java.awt.Window root) {
    }

    /**
     * A convenient static getter for the application instance.
     * @return the instance of BigSIPPerformanceApp
     */
    public static BigSIPPerformanceApp getApplication() {
        return Application.getInstance(BigSIPPerformanceApp.class);
    }

    /**
     * Main method launching the application.
     */
    public static void main(String[] args) {
        initialize();
        launch(BigSIPPerformanceApp.class, args);
        
    }

    private static void initialize(){
        config = new Configurations();
        
        
        config.sippLoc = ShellCommand.execute("which sipp");
        config.opensipsLoc = ShellCommand.execute("which opensips");
        
    }
}
