/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package bigsipperformance;

import java.awt.image.BufferedImage;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.util.Arrays;
import java.util.HashMap;
import javax.swing.ImageIcon;
import javax.swing.JLabel;
import org.jfree.chart.ChartFactory;
import org.jfree.chart.ChartUtilities;
import org.jfree.chart.JFreeChart;
import org.jfree.chart.plot.PlotOrientation;
import org.jfree.data.category.DefaultCategoryDataset;
import org.jfree.data.xy.XYSeries;
import org.jfree.data.xy.XYSeriesCollection;

/**
 *
 * @author big
 */
public class ReadResultThread extends Thread {
    private TestFrame parent;
    private boolean finish = false;
    private FileReader resultFile;
    private double interval;
    private JLabel target, target2, target3, target4;
    private JFreeChart chart, chart2, chart3, chart4;
   
    private XYSeries createdCall, successful, failed, current;
    private XYSeriesCollection dataset1;
    private DefaultCategoryDataset RTime, CTime, meanRTime, meanCTime;

    private int meanRTimeColumn = -1;
    private int meanCTimeColumn = -1;
    private int RTimePartitionStart = -1;
    private int RTimePartitionEnd = -1;
    private int CTimePartitionStart = -1;
    private int CTimePartitionEnd = -1;
    private String[] RTimePartitions, CTimePartitions;
    private int lastRate = -1;
    private double[] lastRTime, deductRTime, lastCTime, deductCTime;
    private int RTimeCounter, CTimeCounter;
    private double RTimeTotal, CTimeTotal;



    
    
    
    private class percentageValue{public double value, total, percent;}

    private HashMap<Integer, percentageValue> failedCallPercentage = new HashMap<Integer, percentageValue>();
    //private double[][] failedCallPercentage;
    //private StandardChartTheme theme;
   // private XYLineAndShapeRenderer renderer;

    public ReadResultThread(TestFrame parent, JLabel target, JLabel target2, JLabel target3, JLabel target4){
        this.parent = parent;
        this.resultFile = parent.resultFR;
        this.interval = parent.pollingInterval;
        
        this.target = target;
        this.target2 = target2;
        this.target3 = target3;
        this.target4 = target4;
    }

    @Override
    public void run() {
        initGraphs();
        System.out.println("Thread started");
        //periodically update the result

        while(!finish){
            readFile();
            plotGraph();
            try {sleep((int)(interval * 1000));} catch (Exception e){}
        }
        saveGraphs();        
    }

    public void finish(){
        finish = true;
    }

    private void initGraphs(){
        createdCall = new XYSeries("Created Call",true,false);
        successful = new XYSeries("Successful Call",true,false);
        failed = new XYSeries("Failed Call",true,false);
        current = new XYSeries("Current Call",true,false);


        dataset1 = new XYSeriesCollection();
        dataset1.addSeries(createdCall);
        dataset1.addSeries(successful);
        dataset1.addSeries(failed);
        dataset1.addSeries(current);

        RTime = new DefaultCategoryDataset();
        CTime = new DefaultCategoryDataset();
        meanRTime = new DefaultCategoryDataset();
        meanCTime = new DefaultCategoryDataset();



    }

    private void readFile() {
        try {
            //read file to the result array
            BufferedReader buffer = new BufferedReader(resultFile);
            String record = null;
            while ((record = buffer.readLine()) != null) {
                String[] temp = record.split(";");
                //ignore the header line
                if (temp[0].equalsIgnoreCase("starttime")) {
                    int i=0;
                    //find the column of the mean response time
                    while(i<temp.length && !temp[i].matches("ResponseTime\\d\\(P\\)"))i++;
                    if(temp[i].matches("ResponseTime\\d\\(P\\)")) meanRTimeColumn = i;
                    //find the column of the mean call length
                    while(i<temp.length && !temp[i].matches("CallLength\\(P\\)")) i++;
                    if(temp[i].matches("CallLength\\(P\\)")) meanCTimeColumn = i;
                    
                    //find the columns of the partition of response time
                    while(i<temp.length && !temp[i].matches("ResponseTimeRepartition\\d")) i++;
                    if(temp[i].matches("ResponseTimeRepartition\\d")) RTimePartitionStart = ++i;
                    while(i<temp.length && (temp[i].contains("<") || temp[i].contains(">"))) i++;
                    RTimePartitionEnd = i;

                    //find the columns of the partition of call length
                    while(i<temp.length && !temp[i].matches("CallLengthRepartition")) i++;
                    if(temp[i].matches("CallLengthRepartition")) CTimePartitionStart = ++i;
                    while(i<temp.length && (temp[i].contains("<") || temp[i].contains(">"))) i++;
                    CTimePartitionEnd = i;

                    if(RTimePartitionEnd-RTimePartitionStart > 0){
                        RTimePartitions = new String[RTimePartitionEnd-RTimePartitionStart];
                        lastRTime = new double[RTimePartitionEnd-RTimePartitionStart];
                        deductRTime = new double[RTimePartitionEnd-RTimePartitionStart];
                        for(int j=0;j<RTimePartitions.length;j++){
                            RTimePartitions[j] = temp[RTimePartitionStart+j];
                            lastRTime[j] = 0;
                        }

                    }
                    if(CTimePartitionEnd-CTimePartitionStart > 0){
                        CTimePartitions = new String[CTimePartitionEnd-CTimePartitionStart];
                        lastCTime = new double[CTimePartitionEnd-CTimePartitionStart];
                        deductCTime = new double[CTimePartitionEnd-CTimePartitionStart];
                        for(int j=0;j<CTimePartitions.length;j++){
                            CTimePartitions[j] = temp[CTimePartitionStart+j];
                            lastCTime[j] = 0;
                        }
                    }
                    


                    for(int j=0;j<RTimePartitions.length;j++)
                        System.out.print(RTimePartitions[j]+" ");
                    System.out.println();

                    for(int j=0;j<CTimePartitions.length;j++)
                        System.out.print(CTimePartitions[j]+" ");
                    System.out.println();

                    
                    return;
                    
                }

                //add data to the series
                int col = 0;

                double elapsed = Integer.valueOf(temp[3].substring(0, 2)) * 3600;
                elapsed += Integer.valueOf(temp[3].substring(3, 5)) * 60;
                elapsed += Integer.valueOf(temp[3].substring(6, 8));
                System.out.println(temp[3] + " " + elapsed);

  
                //time in the format HH:MM:SS
                int seconds = Integer.valueOf(temp[4].substring(0, 2)) * 3600;
                seconds += Integer.valueOf(temp[4].substring(3, 5)) * 60;
                seconds += Integer.valueOf(temp[4].substring(6, 8));


                createdCall.add(seconds, Double.valueOf(temp[10]) / elapsed);
                successful.add(seconds, Double.valueOf(temp[14]) / elapsed);
                failed.add(seconds, Double.valueOf(temp[16]) / elapsed);
                current.add(seconds, Double.valueOf(temp[13]) / elapsed);

                //for a specific target rate, update the failed percentage
                int targetRate = Integer.valueOf(temp[5]);
                //System.out.println("target rate : "+targetRate);
                percentageValue newValue = failedCallPercentage.get(targetRate);
                if(newValue == null){
                    newValue = new percentageValue();
                    newValue.value = 0;
                    newValue.total = 0;
                }
                newValue.value += Double.valueOf(temp[16]);
                newValue.total += Double.valueOf(temp[10]);
                newValue.percent = (newValue.total>0)?newValue.value*100/newValue.total:0;
                failedCallPercentage.put(targetRate, newValue);



                //meanRTimeColumn, meanCTimeColumn
                double milliSec = Double.valueOf(temp[meanRTimeColumn].substring(0, 2)) * 3600000;
                milliSec += Double.valueOf(temp[meanRTimeColumn].substring(3, 5)) * 60000;
                milliSec += Double.valueOf(temp[meanRTimeColumn].substring(6, 8)) * 1000;
                milliSec += Double.valueOf(temp[meanRTimeColumn].substring(9, 12));

                //store the value
                if(milliSec > 0){
                    if(targetRate != lastRate){
                        //reset the variables
                        RTimeCounter = 0;
                        RTimeTotal = 0;
                    }
                    RTimeTotal += milliSec;
                    RTimeCounter++;
                    meanRTime.addValue(RTimeTotal/(double)RTimeCounter, "Average Response Time", targetRate+"");
                    //System.out.println("current="+milliSec+" overall="+RTimeTotal/(double)RTimeCounter);
                }


                milliSec = Double.valueOf(temp[meanCTimeColumn].substring(0, 2)) * 3600000;
                milliSec += Double.valueOf(temp[meanCTimeColumn].substring(3, 5)) * 60000;
                milliSec += Double.valueOf(temp[meanCTimeColumn].substring(6, 8)) * 1000;
                milliSec += Double.valueOf(temp[meanCTimeColumn].substring(9, 12));

                //store the value
                if(milliSec > 0){
                    if(targetRate != lastRate){
                        //reset the variables
                        CTimeCounter = 0;
                        CTimeTotal = 0;
                    }
                    CTimeTotal += milliSec;
                    CTimeCounter++;
                    meanCTime.addValue(CTimeTotal/(double)CTimeCounter, "Average Call Length", targetRate+"");
                    //System.out.println("current="+milliSec+" overall="+RTimeTotal/(double)RTimeCounter);
                }

                
                if(RTimePartitionEnd-RTimePartitionStart > 0){
                    if(targetRate != lastRate){
                        
                        //update deductRTime to the value in lastRTime
                        for(int j=0;j<RTimePartitions.length;j++)
                            deductRTime[j] = lastRTime[j];
                    }
                    double base = 0;
                    for(int j=0;j<RTimePartitions.length;j++){
                        lastRTime[j]=Double.valueOf(temp[RTimePartitionStart+j]);
                        base+=lastRTime[j]-deductRTime[j];
                    }
                    if(base<1) base = 1;
                    for(int j=0;j<RTimePartitions.length;j++)
                        RTime.addValue((Double.valueOf(temp[RTimePartitionStart+j])-deductRTime[j])*100/base, RTimePartitions[j]+" ms", targetRate+"");
                }
                    


                if(CTimePartitionEnd-CTimePartitionStart > 0){
                    if(targetRate != lastRate){

                        //update deductRTime to the value in lastRTime
                        for(int j=0;j<CTimePartitions.length;j++)
                            deductCTime[j] = lastCTime[j];
                    }
                    double base = 0;
                    for(int j=0;j<CTimePartitions.length;j++){
                        lastCTime[j]=Double.valueOf(temp[CTimePartitionStart+j]);
                        base+=lastCTime[j]-deductCTime[j];
                    }
                    if(base<1) base = 1;

                    for(int j=0;j<CTimePartitions.length;j++)
                        CTime.addValue((Double.valueOf(temp[CTimePartitionStart+j])-deductCTime[j])*100/base, CTimePartitions[j]+"ms", targetRate+"");
                }




                //update the variable
                lastRate = targetRate;



                      
            }

        } catch (Exception e) {
            e.printStackTrace();
        }

    }

    private void plotGraph() {

        DefaultCategoryDataset failedCallDataset = new DefaultCategoryDataset();
        Integer[] failedCallRate = failedCallPercentage.keySet().toArray(new Integer[0]);
        Arrays.sort(failedCallRate);

        for(int rate : failedCallRate)
            failedCallDataset.addValue(failedCallPercentage.get(rate).percent, "", ""+rate);
      
        chart = ChartUtility.createXYLineChart("Successful/Failed Calls", "Elapsed Time (s)", "Number of Calls (cps)", dataset1, PlotOrientation.VERTICAL, true); 
        chart2 = ChartUtility.createCategoryChart("Call Failure at Different Call Rates", "Target Rate (cps)", "Failed Calls (%)", failedCallDataset, PlotOrientation.VERTICAL, false);
   
        //JFreeChart chart3 = ChartFactory.createBarChart("", "Response Time (ms)", "Percentage of Calls (%)", RTime, PlotOrientation.VERTICAL, true, false, false);
        //JFreeChart chart3 = ChartFactory.createStackedBarChart("Title", "Target Rate (cps)", "Percent (%)", RTime, PlotOrientation.VERTICAL, true, false, false);
        chart3 = ChartUtility.createDualPlotChart("Call Response Time at Different Call Rates", "Target Rate (cps)", "Distribution of the Response Time (%)", "Average Response Time (ms)", RTime, meanRTime, PlotOrientation.VERTICAL, true);
        chart4 = ChartUtility.createDualPlotChart("Call Length at Different Call Rates", "Target Rate (cps)", "Distribution of the Call Length (%)", "Average Call Length (ms)", CTime, meanCTime, PlotOrientation.VERTICAL, true);


        

        BufferedImage image = chart.createBufferedImage(500,400);
        BufferedImage image2 = chart2.createBufferedImage(500, 400);
        BufferedImage image3 = chart3.createBufferedImage(500, 400);
        BufferedImage image4 = chart4.createBufferedImage(500, 400);
        target.setIcon(new ImageIcon(image));
        target2.setIcon(new ImageIcon(image2));
        target3.setIcon(new ImageIcon(image3));
        target4.setIcon(new ImageIcon(image4));
        

    }

    private void saveGraphs(){
        try{
            
            File file1 = new File(parent.baseDir+"/graph-1.png");
            File file2 = new File(parent.baseDir+"/graph-2.png");
            File file3 = new File(parent.baseDir+"/graph-3.png");
            File file4 = new File(parent.baseDir+"/graph-4.png");
            ChartUtilities.saveChartAsPNG(file1, chart, 500, 400);
            ChartUtilities.saveChartAsPNG(file2, chart2, 500, 400);
            ChartUtilities.saveChartAsPNG(file3, chart3, 500, 400);
            ChartUtilities.saveChartAsPNG(file4, chart4, 500, 400);
        }catch(Exception e){}
    }

}
