/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * TestFrame.java
 *
 * Created on Mar 7, 2009, 11:15:05 AM
 */

package bigsipperformance;


import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import javax.swing.JOptionPane;
import javax.swing.WindowConstants;
import javax.swing.event.InternalFrameAdapter;
import javax.swing.event.InternalFrameEvent;
import org.jdesktop.application.Action;

/**
 *
 * @author big
 */
public class TestFrame extends javax.swing.JInternalFrame {
    public Configurations config;
    public String baseDir;
    public String processID = null;
    public FileReader resultFR;
    private int controlPort;
    public int pollingInterval, duration;
    private ControlThread controlThread = null;
    private TimerThread timerThread = null;
    private ReadResultThread readResultThread = null;



    /** Creates new form TestFrame */
    public TestFrame(String title, Configurations config) {
        super(title);

        initComponents();
        
        //ask before closing
        setDefaultCloseOperation(WindowConstants.DO_NOTHING_ON_CLOSE);
        addInternalFrameListener(new InternalFrameAdapter() {
        public void internalFrameClosing(InternalFrameEvent e) {
            String text = "Do you want to quit this test ?";
            if(processID != null)
                text += "\nThe active SIPp process will be stopped!";
            int result = JOptionPane.showConfirmDialog(null, text,"Closing the test.", JOptionPane.YES_NO_OPTION);

            if (result == JOptionPane.YES_OPTION){
                close();
                dispose();
            }
                
            
        }
        });


        this.config = config;
        //Disable the result tab
        tabbedPanel.setEnabledAt(1, false);
        tabbedPanel.setEnabledAt(2, false);
        tabbedPanel.setEnabledAt(3, false);
        tabbedPanel.setEnabledAt(4, false);

        //Show the IP settings
        updateIPSettings(scenarioChoice.getSelectedItem().toString());

        //Generate new base directory
        baseDir = "test-" + (new SimpleDateFormat("yyyyMMdd_HHmmss")).format(Calendar.getInstance().getTime());
        ShellCommand.execute("mkdir "+baseDir);


        //for testing purpose
        callerIPText.setText("192.168.100.234");
        callerPortText.setText("5060");
        //callerIDText.setText("55555");
        proxyIPText.setText("192.168.100.1");
        proxyPortText.setText("5060");
        dstNumberText.setText("90188000");
        callRateText.setText("5");
        durationText.setText("180");
        intervalText.setText("10");

        startRateText.setText("2");
        endRateText.setText("20");
        stepText.setText("2");
        aTimeText.setText("180");
        pTimeText.setText("0");
        interval1Text.setText("20");


       
    }

    private void updateIPSettings(String scenario){
        if(scenario.equalsIgnoreCase("simple call")){
            

        }
        else if(scenario.equalsIgnoreCase("queue")){

        }
        else if(scenario.equalsIgnoreCase("call hunting")){

        }

    }


 
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        tabbedPanel = new javax.swing.JTabbedPane();
        settingsPanel = new javax.swing.JPanel();
        scenarioChoice = new javax.swing.JComboBox();
        jLabel1 = new javax.swing.JLabel();
        jSeparator1 = new javax.swing.JSeparator();
        jLabel2 = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        callerIPText = new javax.swing.JTextField();
        proxyIPText = new javax.swing.JTextField();
        dstNumberText = new javax.swing.JTextField();
        jLabel7 = new javax.swing.JLabel();
        processButton = new javax.swing.JButton();
        LoadPatternPanel = new javax.swing.JTabbedPane();
        pattern1Panel = new javax.swing.JPanel();
        jLabel10 = new javax.swing.JLabel();
        intervalText = new javax.swing.JTextField();
        jLabel9 = new javax.swing.JLabel();
        durationText = new javax.swing.JTextField();
        jLabel8 = new javax.swing.JLabel();
        callRateText = new javax.swing.JTextField();
        pattern2Panel = new javax.swing.JPanel();
        jLabel11 = new javax.swing.JLabel();
        interval1Text = new javax.swing.JTextField();
        jLabel12 = new javax.swing.JLabel();
        aTimeText = new javax.swing.JTextField();
        jLabel13 = new javax.swing.JLabel();
        startRateText = new javax.swing.JTextField();
        endRateText = new javax.swing.JTextField();
        jLabel14 = new javax.swing.JLabel();
        jLabel15 = new javax.swing.JLabel();
        stepText = new javax.swing.JTextField();
        pTimeText = new javax.swing.JTextField();
        jLabel16 = new javax.swing.JLabel();
        jLabel5 = new javax.swing.JLabel();
        proxyPortText = new javax.swing.JTextField();
        jLabel6 = new javax.swing.JLabel();
        callerPortText = new javax.swing.JTextField();
        resultPanel = new javax.swing.JPanel();
        graphLabel = new javax.swing.JLabel();
        resultPanel2 = new javax.swing.JPanel();
        graphLabel2 = new javax.swing.JLabel();
        resultPanel3 = new javax.swing.JPanel();
        graphLabel3 = new javax.swing.JLabel();
        resultPanel4 = new javax.swing.JPanel();
        graphLabel4 = new javax.swing.JLabel();

        setClosable(true);
        setName("Form"); // NOI18N
        setPreferredSize(new java.awt.Dimension(700, 500));
        setRequestFocusEnabled(false);
        try {
            setSelected(true);
        } catch (java.beans.PropertyVetoException e1) {
            e1.printStackTrace();
        }
        setVisible(true);

        tabbedPanel.setName("tabbedPanel"); // NOI18N

        settingsPanel.setName("settingsPanel"); // NOI18N

        scenarioChoice.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Simple Call", "Queue", "Call Hunting" }));
        scenarioChoice.setName("scenarioChoice"); // NOI18N
        scenarioChoice.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                scenarioChoiceItemStateChanged(evt);
            }
        });

        org.jdesktop.application.ResourceMap resourceMap = org.jdesktop.application.Application.getInstance(bigsipperformance.BigSIPPerformanceApp.class).getContext().getResourceMap(TestFrame.class);
        jLabel1.setText(resourceMap.getString("jLabel1.text")); // NOI18N
        jLabel1.setName("jLabel1"); // NOI18N

        jSeparator1.setOrientation(javax.swing.SwingConstants.VERTICAL);
        jSeparator1.setName("jSeparator1"); // NOI18N

        jLabel2.setText(resourceMap.getString("jLabel2.text")); // NOI18N
        jLabel2.setName("jLabel2"); // NOI18N

        jLabel3.setText(resourceMap.getString("jLabel3.text")); // NOI18N
        jLabel3.setName("jLabel3"); // NOI18N

        jLabel4.setText(resourceMap.getString("jLabel4.text")); // NOI18N
        jLabel4.setName("jLabel4"); // NOI18N

        callerIPText.setColumns(10);
        callerIPText.setText(resourceMap.getString("callerIPText.text")); // NOI18N
        callerIPText.setName("callerIPText"); // NOI18N

        proxyIPText.setColumns(10);
        proxyIPText.setText(resourceMap.getString("proxyIPText.text")); // NOI18N
        proxyIPText.setName("proxyIPText"); // NOI18N

        dstNumberText.setColumns(10);
        dstNumberText.setText(resourceMap.getString("dstNumberText.text")); // NOI18N
        dstNumberText.setName("dstNumberText"); // NOI18N

        jLabel7.setText(resourceMap.getString("jLabel7.text")); // NOI18N
        jLabel7.setName("jLabel7"); // NOI18N

        javax.swing.ActionMap actionMap = org.jdesktop.application.Application.getInstance(bigsipperformance.BigSIPPerformanceApp.class).getContext().getActionMap(TestFrame.class, this);
        processButton.setAction(actionMap.get("startTest")); // NOI18N
        processButton.setText(resourceMap.getString("processButton.text")); // NOI18N
        processButton.setName("processButton"); // NOI18N
        processButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                processButtonActionPerformed(evt);
            }
        });

        LoadPatternPanel.setName("LoadPatternPanel"); // NOI18N

        pattern1Panel.setName("pattern1Panel"); // NOI18N

        jLabel10.setText(resourceMap.getString("jLabel10.text")); // NOI18N
        jLabel10.setName("jLabel10"); // NOI18N

        intervalText.setColumns(5);
        intervalText.setName("intervalText"); // NOI18N

        jLabel9.setText(resourceMap.getString("jLabel9.text")); // NOI18N
        jLabel9.setName("jLabel9"); // NOI18N

        durationText.setColumns(5);
        durationText.setName("durationText"); // NOI18N

        jLabel8.setText(resourceMap.getString("jLabel8.text")); // NOI18N
        jLabel8.setName("jLabel8"); // NOI18N

        callRateText.setColumns(5);
        callRateText.setText(resourceMap.getString("callRateText.text")); // NOI18N
        callRateText.setName("callRateText"); // NOI18N

        javax.swing.GroupLayout pattern1PanelLayout = new javax.swing.GroupLayout(pattern1Panel);
        pattern1Panel.setLayout(pattern1PanelLayout);
        pattern1PanelLayout.setHorizontalGroup(
            pattern1PanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pattern1PanelLayout.createSequentialGroup()
                .addGap(30, 30, 30)
                .addGroup(pattern1PanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(pattern1PanelLayout.createSequentialGroup()
                        .addGap(6, 6, 6)
                        .addGroup(pattern1PanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addGroup(pattern1PanelLayout.createSequentialGroup()
                                .addComponent(jLabel9)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(durationText, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                            .addGroup(pattern1PanelLayout.createSequentialGroup()
                                .addComponent(jLabel8)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(callRateText, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))))
                    .addGroup(pattern1PanelLayout.createSequentialGroup()
                        .addComponent(jLabel10)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(intervalText, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap(29, Short.MAX_VALUE))
        );
        pattern1PanelLayout.setVerticalGroup(
            pattern1PanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pattern1PanelLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(pattern1PanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel8)
                    .addComponent(callRateText, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(12, 12, 12)
                .addGroup(pattern1PanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel9)
                    .addComponent(durationText, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(pattern1PanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel10)
                    .addComponent(intervalText, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(115, Short.MAX_VALUE))
        );

        LoadPatternPanel.addTab(resourceMap.getString("pattern1Panel.TabConstraints.tabTitle"), pattern1Panel); // NOI18N

        pattern2Panel.setName("pattern2Panel"); // NOI18N

        jLabel11.setText(resourceMap.getString("jLabel11.text")); // NOI18N
        jLabel11.setName("jLabel11"); // NOI18N

        interval1Text.setColumns(5);
        interval1Text.setName("interval1Text"); // NOI18N

        jLabel12.setText(resourceMap.getString("jLabel12.text")); // NOI18N
        jLabel12.setName("jLabel12"); // NOI18N

        aTimeText.setColumns(5);
        aTimeText.setName("aTimeText"); // NOI18N

        jLabel13.setText(resourceMap.getString("jLabel13.text")); // NOI18N
        jLabel13.setName("jLabel13"); // NOI18N

        startRateText.setColumns(5);
        startRateText.setName("startRateText"); // NOI18N

        endRateText.setColumns(5);
        endRateText.setName("endRateText"); // NOI18N

        jLabel14.setText(resourceMap.getString("jLabel14.text")); // NOI18N
        jLabel14.setName("jLabel14"); // NOI18N

        jLabel15.setText(resourceMap.getString("jLabel15.text")); // NOI18N
        jLabel15.setName("jLabel15"); // NOI18N

        stepText.setColumns(5);
        stepText.setName("stepText"); // NOI18N

        pTimeText.setColumns(5);
        pTimeText.setName("pTimeText"); // NOI18N

        jLabel16.setText(resourceMap.getString("jLabel16.text")); // NOI18N
        jLabel16.setName("jLabel16"); // NOI18N

        javax.swing.GroupLayout pattern2PanelLayout = new javax.swing.GroupLayout(pattern2Panel);
        pattern2Panel.setLayout(pattern2PanelLayout);
        pattern2PanelLayout.setHorizontalGroup(
            pattern2PanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pattern2PanelLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(pattern2PanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addGroup(pattern2PanelLayout.createSequentialGroup()
                        .addComponent(jLabel11)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(interval1Text, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(pattern2PanelLayout.createSequentialGroup()
                        .addComponent(jLabel16)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(pTimeText, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(pattern2PanelLayout.createSequentialGroup()
                        .addComponent(jLabel12)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(aTimeText, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(pattern2PanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                        .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, pattern2PanelLayout.createSequentialGroup()
                            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 39, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(jLabel14)
                            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                            .addComponent(endRateText, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addGroup(pattern2PanelLayout.createSequentialGroup()
                            .addGap(32, 32, 32)
                            .addComponent(jLabel13)
                            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                            .addComponent(startRateText, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, pattern2PanelLayout.createSequentialGroup()
                            .addComponent(jLabel15)
                            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                            .addComponent(stepText, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))))
                .addContainerGap(28, Short.MAX_VALUE))
        );
        pattern2PanelLayout.setVerticalGroup(
            pattern2PanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pattern2PanelLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(pattern2PanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel13)
                    .addComponent(startRateText, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(pattern2PanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel14)
                    .addComponent(endRateText, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(pattern2PanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel15)
                    .addComponent(stepText, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(pattern2PanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(aTimeText, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel12))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(pattern2PanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(pTimeText, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel16))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(pattern2PanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(interval1Text, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel11))
                .addContainerGap(37, Short.MAX_VALUE))
        );

        LoadPatternPanel.addTab(resourceMap.getString("pattern2Panel.TabConstraints.tabTitle"), pattern2Panel); // NOI18N

        jLabel5.setText(resourceMap.getString("jLabel5.text")); // NOI18N
        jLabel5.setName("jLabel5"); // NOI18N

        proxyPortText.setColumns(10);
        proxyPortText.setName("proxyPortText"); // NOI18N

        jLabel6.setText(resourceMap.getString("jLabel6.text")); // NOI18N
        jLabel6.setName("jLabel6"); // NOI18N

        callerPortText.setColumns(10);
        callerPortText.setName("callerPortText"); // NOI18N

        javax.swing.GroupLayout settingsPanelLayout = new javax.swing.GroupLayout(settingsPanel);
        settingsPanel.setLayout(settingsPanelLayout);
        settingsPanelLayout.setHorizontalGroup(
            settingsPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(settingsPanelLayout.createSequentialGroup()
                .addGap(30, 30, 30)
                .addGroup(settingsPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addGroup(settingsPanelLayout.createSequentialGroup()
                        .addComponent(jLabel1)
                        .addGap(3, 3, 3)
                        .addComponent(scenarioChoice, javax.swing.GroupLayout.PREFERRED_SIZE, 183, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(settingsPanelLayout.createSequentialGroup()
                        .addComponent(jLabel4)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(dstNumberText, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(settingsPanelLayout.createSequentialGroup()
                        .addGroup(settingsPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addComponent(jLabel5)
                            .addComponent(jLabel3))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(settingsPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(proxyPortText, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(proxyIPText, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                    .addGroup(settingsPanelLayout.createSequentialGroup()
                        .addComponent(jLabel6)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(callerPortText, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(settingsPanelLayout.createSequentialGroup()
                        .addComponent(jLabel2)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(callerIPText, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jSeparator1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGroup(settingsPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(settingsPanelLayout.createSequentialGroup()
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(settingsPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(settingsPanelLayout.createSequentialGroup()
                                .addGap(31, 31, 31)
                                .addComponent(LoadPatternPanel, javax.swing.GroupLayout.PREFERRED_SIZE, 258, javax.swing.GroupLayout.PREFERRED_SIZE))
                            .addComponent(jLabel7))
                        .addContainerGap(56, Short.MAX_VALUE))
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, settingsPanelLayout.createSequentialGroup()
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(processButton)
                        .addGap(15, 15, 15))))
        );
        settingsPanelLayout.setVerticalGroup(
            settingsPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(settingsPanelLayout.createSequentialGroup()
                .addGroup(settingsPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(settingsPanelLayout.createSequentialGroup()
                        .addGap(22, 22, 22)
                        .addComponent(jLabel7)
                        .addGroup(settingsPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(settingsPanelLayout.createSequentialGroup()
                                .addGap(15, 15, 15)
                                .addGroup(settingsPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                                    .addComponent(jLabel1)
                                    .addComponent(scenarioChoice, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                                .addGap(24, 24, 24)
                                .addGroup(settingsPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                                    .addComponent(jLabel2)
                                    .addComponent(callerIPText, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addGroup(settingsPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                                    .addComponent(jLabel6)
                                    .addComponent(callerPortText, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addGroup(settingsPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                                    .addComponent(jLabel4)
                                    .addComponent(dstNumberText, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addGroup(settingsPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                                    .addComponent(jLabel3)
                                    .addComponent(proxyIPText, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addGroup(settingsPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                                    .addComponent(jLabel5)
                                    .addComponent(proxyPortText, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                            .addGroup(settingsPanelLayout.createSequentialGroup()
                                .addGap(18, 18, 18)
                                .addComponent(LoadPatternPanel, javax.swing.GroupLayout.PREFERRED_SIZE, 263, javax.swing.GroupLayout.PREFERRED_SIZE))))
                    .addGroup(settingsPanelLayout.createSequentialGroup()
                        .addGap(35, 35, 35)
                        .addComponent(jSeparator1, javax.swing.GroupLayout.PREFERRED_SIZE, 370, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap(25, Short.MAX_VALUE))
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, settingsPanelLayout.createSequentialGroup()
                .addContainerGap(392, Short.MAX_VALUE)
                .addComponent(processButton)
                .addContainerGap())
        );

        tabbedPanel.addTab(resourceMap.getString("settingsPanel.TabConstraints.tabTitle"), settingsPanel); // NOI18N

        resultPanel.setName("resultPanel"); // NOI18N

        graphLabel.setText(resourceMap.getString("graphLabel.text")); // NOI18N
        graphLabel.setName("graphLabel"); // NOI18N

        javax.swing.GroupLayout resultPanelLayout = new javax.swing.GroupLayout(resultPanel);
        resultPanel.setLayout(resultPanelLayout);
        resultPanelLayout.setHorizontalGroup(
            resultPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(resultPanelLayout.createSequentialGroup()
                .addGap(118, 118, 118)
                .addComponent(graphLabel, javax.swing.GroupLayout.PREFERRED_SIZE, 505, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(55, Short.MAX_VALUE))
        );
        resultPanelLayout.setVerticalGroup(
            resultPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(resultPanelLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(graphLabel, javax.swing.GroupLayout.DEFAULT_SIZE, 406, Short.MAX_VALUE)
                .addContainerGap())
        );

        tabbedPanel.addTab(resourceMap.getString("resultPanel.TabConstraints.tabTitle"), resultPanel); // NOI18N

        resultPanel2.setName("resultPanel2"); // NOI18N

        graphLabel2.setText(resourceMap.getString("graphLabel2.text")); // NOI18N
        graphLabel2.setName("graphLabel2"); // NOI18N

        javax.swing.GroupLayout resultPanel2Layout = new javax.swing.GroupLayout(resultPanel2);
        resultPanel2.setLayout(resultPanel2Layout);
        resultPanel2Layout.setHorizontalGroup(
            resultPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(resultPanel2Layout.createSequentialGroup()
                .addGap(26, 26, 26)
                .addComponent(graphLabel2, javax.swing.GroupLayout.PREFERRED_SIZE, 526, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(126, Short.MAX_VALUE))
        );
        resultPanel2Layout.setVerticalGroup(
            resultPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(resultPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(graphLabel2, javax.swing.GroupLayout.PREFERRED_SIZE, 397, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(21, Short.MAX_VALUE))
        );

        tabbedPanel.addTab(resourceMap.getString("resultPanel2.TabConstraints.tabTitle"), resultPanel2); // NOI18N

        resultPanel3.setName("resultPanel3"); // NOI18N

        graphLabel3.setName("graphLabel3"); // NOI18N

        javax.swing.GroupLayout resultPanel3Layout = new javax.swing.GroupLayout(resultPanel3);
        resultPanel3.setLayout(resultPanel3Layout);
        resultPanel3Layout.setHorizontalGroup(
            resultPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 678, Short.MAX_VALUE)
            .addGroup(resultPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addGroup(resultPanel3Layout.createSequentialGroup()
                    .addGap(76, 76, 76)
                    .addComponent(graphLabel3, javax.swing.GroupLayout.PREFERRED_SIZE, 526, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addContainerGap(76, Short.MAX_VALUE)))
        );
        resultPanel3Layout.setVerticalGroup(
            resultPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 430, Short.MAX_VALUE)
            .addGroup(resultPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addGroup(resultPanel3Layout.createSequentialGroup()
                    .addGap(16, 16, 16)
                    .addComponent(graphLabel3, javax.swing.GroupLayout.PREFERRED_SIZE, 397, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addContainerGap(17, Short.MAX_VALUE)))
        );

        tabbedPanel.addTab(resourceMap.getString("resultPanel3.TabConstraints.tabTitle"), resultPanel3); // NOI18N

        resultPanel4.setName("resultPanel4"); // NOI18N

        graphLabel4.setName("graphLabel4"); // NOI18N

        javax.swing.GroupLayout resultPanel4Layout = new javax.swing.GroupLayout(resultPanel4);
        resultPanel4.setLayout(resultPanel4Layout);
        resultPanel4Layout.setHorizontalGroup(
            resultPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 678, Short.MAX_VALUE)
            .addGroup(resultPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addGroup(resultPanel4Layout.createSequentialGroup()
                    .addGap(76, 76, 76)
                    .addComponent(graphLabel4, javax.swing.GroupLayout.PREFERRED_SIZE, 526, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addContainerGap(76, Short.MAX_VALUE)))
        );
        resultPanel4Layout.setVerticalGroup(
            resultPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 430, Short.MAX_VALUE)
            .addGroup(resultPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addGroup(resultPanel4Layout.createSequentialGroup()
                    .addGap(16, 16, 16)
                    .addComponent(graphLabel4, javax.swing.GroupLayout.PREFERRED_SIZE, 397, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addContainerGap(17, Short.MAX_VALUE)))
        );

        tabbedPanel.addTab(resourceMap.getString("resultPanel4.TabConstraints.tabTitle"), resultPanel4); // NOI18N

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(tabbedPanel, javax.swing.GroupLayout.PREFERRED_SIZE, 690, javax.swing.GroupLayout.PREFERRED_SIZE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(tabbedPanel, javax.swing.GroupLayout.PREFERRED_SIZE, 470, javax.swing.GroupLayout.PREFERRED_SIZE)
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void scenarioChoiceItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_scenarioChoiceItemStateChanged
        // TODO add your handling code here:
        updateIPSettings(scenarioChoice.getSelectedItem().toString());
        
        
}//GEN-LAST:event_scenarioChoiceItemStateChanged

    private void processButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_processButtonActionPerformed
        // TODO add your handling code here:
    }

    @Action
    public void startTest() {
        int started = 0;

        switch(scenarioChoice.getSelectedIndex()){
            //Simple call
            case 0: started = processCall("simple"); break;

            //Queue
            case 1: started = processCall("queue");break;

            //Call Hunting
            case 2: break;
            default: break;
        }

        //if the sipp can be started
        //go to the result page
        if(started > 0){
            tabbedPanel.setEnabledAt(0, false);
            tabbedPanel.setEnabledAt(1, true);
            tabbedPanel.setEnabledAt(2, true);
            tabbedPanel.setEnabledAt(3, true);
            tabbedPanel.setEnabledAt(4, true);
            tabbedPanel.setSelectedIndex(1);
            showResults();
        }else{
            JOptionPane.showMessageDialog(null,"The SIPp cannot be started.\nCheck the settings.");       
        }
    }//GEN-LAST:event_processButtonActionPerformed



    private int processCall(String scenario){
        String callerIP = callerIPText.getText();
        String callerPort = callerPortText.getText();
        String proxyIP = proxyIPText.getText();
        String proxyPort = proxyPortText.getText();
        String dstNumber = dstNumberText.getText();
        int startRate = 0;
        int endRate = 0;
        int increaseStep = 0;
        int activeTime = 0;
        int pauseTime = 0;
        boolean increasing = false;
        controlPort = UDPUtility.getNewAvailablePort();

        
        
        //set up the caller IP address
        //int infOffset = 1;
        //String device = "lo";
        //ShellCommand.execute("echo "+config.rootPassword+" | sudo -S ifconfig "+device+":"+(infOffset++)+" "+callerIP+" up");

        ShellCommand.execute("echo "+config.rootPassword+" | sudo -S ifconfig lo:1 "+callerIP+" up");

        //copy predefined files to the test directory

        ShellCommand.execute("cp ./predefined/"+scenario+"/* ./"+baseDir);

        

        if(LoadPatternPanel.getSelectedIndex() == 0){
            //Pattern: None
            startRate = Integer.valueOf(callRateText.getText());
            pollingInterval = Integer.valueOf(intervalText.getText());
            duration = Integer.valueOf(durationText.getText());

        }else if(LoadPatternPanel.getSelectedIndex() == 1){
            //Pattern: Increasing
            increasing = true;
            startRate = Integer.valueOf(startRateText.getText());
            endRate = Integer.valueOf(endRateText.getText());
            increaseStep = Integer.valueOf(stepText.getText());
            activeTime = Integer.valueOf(aTimeText.getText());
            pauseTime = Integer.valueOf(pTimeText.getText());
            pollingInterval = Integer.valueOf(interval1Text.getText());
            duration = (activeTime+pauseTime)*(endRate-startRate)/increaseStep;
        }
        
        

        
        //compose the sipp command
        String command = config.sippLoc;
        command += " -sf caller.xml ";
        command += proxyIP + ":" + proxyPort + " ";
        command += " -i " + callerIP + " -p " + callerPort + " -s " + dstNumber;
        command += " -r " + startRate;
        command += " -fd "+pollingInterval+"s";
        command += " -trace_stat ";
        command += " -inf numbers.csv";
        command += " -l 1000000000";
        command += " -cp " + controlPort;
        command += " -bg";


        String filename = createScriptFile(command);
        ShellCommand.execute("chmod 755 "+baseDir+"/"+filename);

        //run the test
        String result = ShellCommand.execute2(baseDir,"./script.sh");
        
        //check if the sipp can be started
        if(result.indexOf("[") != -1 && result.indexOf("]")!= -1){
            processID = result.substring(result.indexOf("[")+1, result.indexOf("]"));
            //start the thread to control the load
            if(increasing){
                controlThread = new ControlThread(this, startRate, endRate, increaseStep, activeTime, pauseTime, callerIP, controlPort);
                controlThread.start();
            }else{
                timerThread = new TimerThread(this, duration);
                timerThread.start();
            }
            return 1;
        }
        return -1;
    }


    private void showResults(){
        resultFR = null;

        //get the filename of the result
        String resultFile = baseDir+"/"+ShellCommand.execute2(baseDir, "ls caller.xml_*");

        //test if file can be open for read
        try{
            resultFR = new FileReader(resultFile);
        }catch(Exception e){
            //show file not found error
            System.out.println("File not found");
            return;
        }

        //create new thread to update the result
        readResultThread = new ReadResultThread(this, graphLabel, graphLabel2, graphLabel3, graphLabel4);
        readResultThread.start();

    }



    private String createScriptFile(String command){
        String filename = "script.sh";
        try{
            FileWriter fstream = new FileWriter(baseDir+"/"+filename);
            BufferedWriter out = new BufferedWriter(fstream);
            out.write(command);
            out.close();
        }catch (Exception e){}
        return filename;
    }

    public void close(){

        //kill the threads
        if(controlThread != null)
            controlThread.finish();
        if(readResultThread != null)
            readResultThread.finish();
        if(timerThread != null)
            timerThread.finish();

        //kill the sipp process
        if(processID != null)
        ShellCommand.execute("kill -9 " + processID);
        processID = null;

        //close the file reader
        try {
            resultFR.close();
        } catch (Exception e) {
        }
        
    }




    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JTabbedPane LoadPatternPanel;
    private javax.swing.JTextField aTimeText;
    private javax.swing.JTextField callRateText;
    private javax.swing.JTextField callerIPText;
    private javax.swing.JTextField callerPortText;
    private javax.swing.JTextField dstNumberText;
    private javax.swing.JTextField durationText;
    private javax.swing.JTextField endRateText;
    private javax.swing.JLabel graphLabel;
    private javax.swing.JLabel graphLabel2;
    private javax.swing.JLabel graphLabel3;
    private javax.swing.JLabel graphLabel4;
    private javax.swing.JTextField interval1Text;
    private javax.swing.JTextField intervalText;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel10;
    private javax.swing.JLabel jLabel11;
    private javax.swing.JLabel jLabel12;
    private javax.swing.JLabel jLabel13;
    private javax.swing.JLabel jLabel14;
    private javax.swing.JLabel jLabel15;
    private javax.swing.JLabel jLabel16;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JSeparator jSeparator1;
    private javax.swing.JTextField pTimeText;
    private javax.swing.JPanel pattern1Panel;
    private javax.swing.JPanel pattern2Panel;
    private javax.swing.JButton processButton;
    private javax.swing.JTextField proxyIPText;
    private javax.swing.JTextField proxyPortText;
    private javax.swing.JPanel resultPanel;
    private javax.swing.JPanel resultPanel2;
    private javax.swing.JPanel resultPanel3;
    private javax.swing.JPanel resultPanel4;
    private javax.swing.JComboBox scenarioChoice;
    private javax.swing.JPanel settingsPanel;
    private javax.swing.JTextField startRateText;
    private javax.swing.JTextField stepText;
    private javax.swing.JTabbedPane tabbedPanel;
    // End of variables declaration//GEN-END:variables

}
